
import { EyeOutlined } from '@ant-design/icons';
import { Upload, Button, Modal, Card, Carousel } from 'antd';
import { LeftCircleOutlined, RightCircleOutlined } from '@ant-design/icons'
import React, { Component } from 'react'
import PropTypes from 'prop-types'
import './LwjSowPicList.less'



export default class LwjPic4Absolute extends Component {

  state = {
    fileList: [],
    previewVisible: false,
    previewVisibleUrl: '',
    currentIndex: 0
  };


  handleCancel = () => this.setState({ previewVisible: false, currentIndex: 0 })
  componentDidMount() {

  }
  componentWillUnmount() {
    this.setState({ previewVisible: false, currentIndex: 0 });
  }

  render() {
    const { title, fileSrc } = this.props;
    const { previewVisible } = this.state;
    const fileList = (fileSrc instanceof Array ? fileSrc : [{ url: fileSrc, name: title }])
    const gridStyle = {
      width: '100px',
      textAlign: 'center',
      position: 'relative'
    };
    const toDetail = (e, i) => {
      this.setState({ previewVisible: true, currentIndex: i })
    }
    let slider = null
    const getIMGlist = (files) => {
      if (files.length > 0) {
        const res = files.map((val, i) => <Card.Grid className='LwjSowPicList' style={gridStyle} key={val.uid}>
          <img alt={val.name} src={val.url} style={{ height: 40 }} />
          <div className='LwjSowPicList_showPic_preview'>
            <EyeOutlined
              style={{
                fontSize: 30,
                color: '#fff',
                position: 'absolute',
                left: '50%',
                top: '50%',
                transform: 'translate(-50%, -50%)'
              }}
              at={val}
              onClick={(e) => toDetail(e, i)} />
          </div>
        </Card.Grid>);
        return res;
      }
    }
    return (
      <div style={{ display: 'flex' }}>
        {getIMGlist(fileList)}
        <Modal title="图片预览" visible={previewVisible} footer={null} onCancel={this.handleCancel} zIndex={13658073843} width="700px">
          <div className="LwjSowPicList_imagesBox">
            {fileList?.length > 1 ? (
              <LeftCircleOutlined onClick={() => slider.prev()} className="prev" />
            ) : null}
            <Carousel
              dots={false}
              ref={(el) => {
                slider = el
                el?.goTo(this.state.currentIndex)
              }}
            >
              {fileList?.map((item, i) => (
                <div className="imgBox">
                  <img alt={item.name} src={item.url} alt="" key={i} />
                </div>
              ))}
            </Carousel>
            {fileList?.length > 1 ? (
              <RightCircleOutlined className="next" onClick={() => slider.next()} />
            ) : null}
          </div>
        </Modal>
      </div>
    );
  }
}

LwjPic4Absolute.props = {
  title: PropTypes.string.isRequired,
  fileSrc: PropTypes.string.isRequired
}
