import { EyeOutlined } from '@ant-design/icons';
import { Upload, Button, Modal, Card, Carousel } from 'antd';
import React, { Component } from 'react'
import PropTypes from 'prop-types'
import classnames from 'classnames'
import ImageService from '../_utils/imageService'
import './LwjSowPicList.less'
import { isAbsolute } from 'path';
import { debug } from 'util';
import {LeftCircleOutlined, RightCircleOutlined} from '@ant-design/icons'

export default class LwjSowPicList extends Component {

  state = {
    fileList: [],
    previewVisible: false,
    previewVisibleUrl: '',
    absoluteUrl: '',
    currentIndex: 0
  };

  handleCancel = () => this.setState({ previewVisible: false })

  setAbsoluteUrl = (url) => this.setState({ absoluteUrl: url })

  componentDidMount() {
    if (this.props.fileLists) {
      let picUrlsAAA = this.props.fileLists;
      const {server} = this.props
      const getUrlAAA = (picUrls) => {
        let promiseArr = [];
        const IMAGE_THUMBNAIL_PARAM_ALIOSS = '?x-oss-process=image/resize,m_lfit,h_400,w_400';
        if (picUrls && picUrls.split(';').length > 0) {
          let newpicUrls = picUrls.split(';');
          if (newpicUrls[newpicUrls.length - 1] == "") {
            newpicUrls.pop();
          }
          newpicUrls.map(img => {
            promiseArr.push(new Promise(function (resolve, reject) {
              ImageService.show(img, (imgUrl) => {
                let thumbnail = ''
                if (imgUrl) {
                  thumbnail = imgUrl.split('?')[0] + IMAGE_THUMBNAIL_PARAM_ALIOSS;
                }
                resolve({ url: imgUrl, thumbnail: thumbnail, orginUrl: img });
              }, server);
            }));
          });
          return promiseArr;
        }
      }

      const dealedTargetUrlAAA = getUrlAAA(picUrlsAAA);
      let sureDealedUrlAAA = [];
      dealedTargetUrlAAA.forEach((value, index) => {
        value.then((val) => {
          let newName = val
            .orginUrl
            .split('/')[
            val
              .orginUrl
              .split('/')
              .length - 1
          ];
          sureDealedUrlAAA.push({
            name: newName.slice(-10),
            uid: index,
            url: val.url,
            thumbnail: val.thumbnail,
            orginUrl: val.orginUrl,
            response: {
              result: val.orginUrl
            }
          })
          this.setState({ fileList: sureDealedUrlAAA });
        })
      })
    }
  }

  componentWillUnmount() {
    this.setState({ fileList: [], previewVisible: false, previewVisibleUrl: '' });
  }

  render() {
    const { title, width } = this.props;

    const { fileList, previewVisible, previewVisibleUrl } = this.state;
    let slider = null
    // 生成列表
    const getIMGlist = (files) => {
      if (files.length > 0) {
        const res = files.map((val, i) => <Card.Grid className='LwjSowPicList' style={gridStyle} key={val.uid}>
          <img alt={val.name} src={val.url} style={{ height: 40 }} className={_.isEmpty(width) ? 'LwjSowPicList_showPic' : ''} />
          <div className='LwjSowPicList_showPic_preview'>
            <EyeOutlined
              style={{
                fontSize: 30,
                color: '#fff',
                position: 'absolute',
                left: '50%',
                top: '50%',
                transform: 'translate(-50%, -50%)'
              }}
              at={val}
              onClick={(e) => preView(e, i)} />
          </div>
        </Card.Grid>);
        return res;
      }
    }

    // 布局样式
    const gridStyle = {
      width: _.isEmpty(width) ? '12.5%' : width,
      textAlign: 'center'
    };
    const preView = (e, i) => {
      this.setState({ previewVisible: true, currentIndex: i });
    }

    return (
      <div className="clearfix">
        <Card title={title}>
          {fileList.length > 0 && getIMGlist(fileList)}
        </Card>
        <Modal visible={previewVisible} footer={null} onCancel={this.handleCancel} zIndex={13658073843} destroyOnClose={true} width="700px">
          <div className="LwjSowPicList_imagesBox">
            {fileList?.length > 1 ? (
              <LeftCircleOutlined onClick={() => slider.prev()} className="prev" />
            ) : null}
            <Carousel
              dots={false}
              ref={(el) => {
                slider = el
                el?.goTo(this.state.currentIndex)
              }}
            >
              {fileList?.map((item, i) => (
                <div className="imgBox">
                  <img src={item.url} alt="" key={i} />
                </div>
              ))}
            </Carousel>
            {fileList?.length > 1 ? (
              <RightCircleOutlined className="next" onClick={() => slider.next()} />
            ) : null}
          </div>
        </Modal>
      </div>
    );
  }
}

LwjSowPicList.props = {
  title: PropTypes.string.isRequired,
  fileLists: PropTypes.string.isRequired,
  width: PropTypes.string,
  server: PropTypes.string
}
