import axios from 'axios';
const SERVICE_ENDPOINT = '/services/';

export const URL_GET_PICTURE_URL = SERVICE_ENDPOINT + 'fileDownload?returnType=url';
export const ALIYUN_OSS_URL = '.oss-cn-beijing.aliyuncs.com';
export const ALIYUN_OSS_HW_PARAMS = '?x-oss-process';


class ImageService { }
export const getTenantCodeFromUrl = () => {
    const href = window.location.href?.split('/')?.filter(i => !!i)
    const index = href.findIndex(i => /.com/.test(i)) + 1
    const tenantCode = href[index] || ''
    return `/${tenantCode}${SERVICE_ENDPOINT}`
}
ImageService.show = function (img, onComplete = (imgUrl) => { }, server) {
    if (!server) {
        if (/xsaasp.com/.test(window.location.href)) {
            server = getTenantCodeFromUrl()
        } else {
            server = SERVICE_ENDPOINT
        }
    }
    if (img.indexOf(ALIYUN_OSS_URL) > -1) {
        if (img.indexOf(ALIYUN_OSS_HW_PARAMS) > -1) {
            let imgUrl = img.substring(0, img.indexOf(ALIYUN_OSS_HW_PARAMS));
            onComplete(imgUrl);
        } else {
            onComplete(img);
        }
    } else {
        // 获取远端图片
        axios({
            method: 'get',
            url: server + 'fileDownload?returnType=url' + '&filePath=' + img,
            responseType: 'text'
        }).then(function (response) {
            let imgUrl = response.data;
            onComplete(imgUrl);
        }).catch(function (error) {
            onComplete(null);
        });
        
    }

}

export default ImageService;
