import React, { useState, useEffect } from 'react';
import { CloseOutlined, PlusCircleOutlined } from '@ant-design/icons';
import { Form } from '@ant-design/compatible';
import '@ant-design/compatible/assets/index.css';
import { Input, Col, Row } from 'antd';

const InputGroup = Input.Group;
import './LwjAddAddress.less'


const LwjAddAddress = ({
  maxNum = 3,
  value,
  onChange
}) => {

  const [itemData, changeItemData] = useState([]);
  useEffect(() => {
    changeItemData(value)
  }, [value]);



  /**
   * 添加
   */
  const addItemData = () => {
    if (itemData.length >= maxNum) {
      return false;
    } else {
      itemData.push({
        designName: '',
        designAddress: '',
      });
      onChange(itemData);
    }
  }

  const deleteItem = (index) => {
    itemData.splice(index, 1);
    onChange(itemData ? itemData : []);
  }

  const changeDate = (e, index, key) => {
    itemData[index][key] = e.target.value;
    onChange(itemData);
  }

  /**
   * 
   */
  const getItemData = () => {
    return itemData.map((val, index) => {
      return (
        <InputGroup key={index}>
          <Row gutter={8}>
            <Col span={8}>
              {/* <Form.Item
                style={{ width: '100%' }}
                validateStatus={val.designName ? "success" : "error"}
                help={val.designName ? "" : "请填写设计名称"}
              > */}
              <Input className={_.isEmpty(val.designName) ? 'erroco' : 'greyoco'} onChange={(e) => changeDate(e, index, 'designName')} placeholder="设计名称" value={val.designName} />
              {/* </Form.Item> */}
            </Col>
            <Col span={16} style={{ display: 'flex' }}>
              {/* <Form.Item
                style={{ width: '100%' }}
                validateStatus={val.designAddress ? "success" : "error"}
                help={val.designName ? "" : "请填写设计地址"}
              > */}
              <Input className={_.isEmpty(val.designAddress) ? 'erroco' : 'greyoco'} onChange={(e) => changeDate(e, index, 'designAddress')} placeholder="设计地址" value={val.designAddress} />
              {/* </Form.Item> */}
              <CloseOutlined
                onClick={() => deleteItem(index)}
                style={{ fontSize: 20, marginLeft: 10, paddingTop: 6 }} />
            </Col>
          </Row>
        </InputGroup>
      );
    });
  }



  const getIcon = () => {
    return itemData.length >= maxNum ? <PlusCircleOutlined
      onClick={addItemData}
      style={{ fontSize: 20, marginRight: 10, paddingTop: 6 }} /> : <PlusCircleOutlined
      onClick={addItemData}
      style={{ fontSize: 20, color: '#33bdb8', marginRight: 10, paddingTop: 6 }} />;
  }


  const handleSubmit = () => {

  }
  return (
    <div style={{ display: 'flex' }}>
      {getIcon()}
      <div style={{ flex: 1 }}>
        {getItemData()}
      </div>
    </div>
  )
}
export default LwjAddAddress
