import React, { useState, useEffect } from 'react';
import { CloseOutlined, PlusOutlined } from '@ant-design/icons';
import { Form } from '@ant-design/compatible';
import '@ant-design/compatible/assets/index.css';
import { Input, Col, Row, Button, message } from 'antd';

const InputGroup = Input.Group;
import './LwjAddIdCardInfo.less'


const LwjAddIdCardInfo = ({
  maxNum = 9999999999,
  value,
  onChange,
  renamekey = 'designName',
  renamevalue = 'designAddress'
}) => {

  const [itemData, changeItemData] = useState([]);
  useEffect(() => {
    changeItemData(value)
  }, [value]);



  /**
   * 添加
   */
  const addItemData = () => {
    if (itemData.length >= maxNum) {
      message.info('已超过最大添加数！');
      return false;
    } else {
      itemData.push({
        [renamekey]: '',
        [renamevalue]: '',
      });
      onChange(itemData);
    }
  }

  const deleteItem = (index) => {
    itemData.splice(index, 1);
    onChange(itemData ? itemData : []);
  }

  const changeDate = (e, index, key) => {
    itemData[index][key] = e.target.value;
    onChange(itemData);
  }

  /**
   * 
   */
  const getItemData = () => {
    return itemData.map((val, index) => {
      return (
        <InputGroup key={index}>
          <Row gutter={8}>
            <Col span={8}>
              <Input className={_.isEmpty(val[renamekey]) ? 'erroco' : 'greyoco'} onChange={(e) => changeDate(e, index, renamekey)} placeholder="姓名" value={val[renamekey]} />
            </Col>
            <Col span={16} style={{ display: 'flex' }}>
              <Input className={_.isEmpty(val[renamevalue]) ? 'erroco' : 'greyoco'} onChange={(e) => changeDate(e, index, renamevalue)} placeholder="身份证号" value={val[renamevalue]} />
              <CloseOutlined
                onClick={() => deleteItem(index)}
                style={{ fontSize: 20, marginLeft: 10, paddingTop: 6 }} />
            </Col>
          </Row>
        </InputGroup>
      );
    });
  }

  return (
    <div>
      <div>
        {getItemData()}
      </div>
      <div>
        <Button type="primary" icon={<PlusOutlined />} onClick={addItemData}>
          联系人身份证信息
        </Button>
      </div>
    </div>
  );
}
export default LwjAddIdCardInfo
